Ext.define('forms.data.proxy.RestWithVersion', {extend:'Ext.data.proxy.Rest', alias:'proxy.formsRestWithVersion', appendId:false, buildUrl:function(request) {
  var me = this;
  var operation = request.getOperation();
  var records = operation.getRecords();
  var record = records ? records[0] : null;
  var version, id, url = me.callParent([request]);
  if (operation.getParams() && operation.getParams().version) {
    version = operation.getParams().version;
  } else if (record) {
    version = record.get('version');
  }
  if (record && !record.phantom) {
    id = record.get('id');
  } else {
    id = operation.getId();
  }
  if (id) {
    var urlTokens = url.split('?');
    url = urlTokens[0] + '/' + id;
    if (version) {
      url = url + '/' + version;
    }
    if (urlTokens[1]) {
      url = Ext.urlAppend(url, urlTokens[1]);
    }
    request.setUrl(url);
  }
  return url;
}});
Ext.define('forms.model.Form', {extend:'Ext.data.Model', requires:['forms.data.proxy.RestWithVersion'], fields:['id', 'version', 'name', 'config', {name:'timestamp', type:'date', dateFormat:'time'}], idProperty:'id', proxy:{type:'formsRestWithVersion', url:'cxf/bpc-forms/forms', writer:{type:'json', writeAllFields:true}}});
Ext.define('forms.store.Forms', {extend:'Ext.data.Store', storeId:'bpcForms', model:'forms.model.Form', sorters:[{property:'timestamp', direction:'DESC'}]});
Ext.define('forms.Config', {singleton:true, requires:['forms.store.Forms'], FORM_URL:'formUrl', RENDERER_URL:'rendererUrl', DEBUG:'debug', EMBEDDED_FORM:'embeddedForm', FORM_ID:'formId', FORM_VERSION:'formVersion', FORMS_ICON_REPOSITORY:'x-fal fa-cabinet-filing', FORMS_ICON:'x-fal fa-ballot-check', FORMS_ICON_URL:'x-fal fa-link', FORMS_ICON_EMBEDDED:'x-fal fa-brackets-curly', FORMS_ICON_CHECK:'x-fal fa-check', MINIMAL_FORMS_CONFIG:{'metaData':{'id':0, 'version':0}, 'configuration':{}, 'components':[{'label':'Forms', 
'type':'textfield'}]}, constructor:function() {
  Ext.create('forms.store.Forms');
}});
Ext.define('forms.view.widget.Widget', {extend:'Ext.panel.Panel', mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:BpcCommon.lang.Current.FORMS_WIDGET_NAME, WIDGET_DESCRIPTION:BpcCommon.lang.Current.FORMS_WIDGET_DESCRIPTION, WIDGET_ICON_CLS:'x-fal fa-ballot-check'}, layout:'card', activeItem:0, configureWidget:function() {
  this.setActiveItem(this.settingPanel);
}, refreshWidget:function() {
}, initComponent:function() {
  var moduleConfiguration = this.getWidgetConfiguration();
  this.chartId = moduleConfiguration.chartId;
  this.moduleId = moduleConfiguration.moduleId;
  this.widgetTitle = moduleConfiguration.title;
  this.widgetIconCls = moduleConfiguration.iconCls;
  this.widgetShowReportTitle = moduleConfiguration.showReportTitle;
  this.stateId = this.stateId + this.moduleId;
  this.callParent();
  this.settingPanel = this.add({xtype:'formsWidgetConfigurator', moduleId:this.moduleId, widgetTitle:this.widgetTitle, showReportTitle:this.widgetShowReportTitle});
  this.wrongConfigPanel = this.add({xtype:'container', padding:'10 10 10 10', layout:{type:'vbox', pack:'center', align:'middle'}, items:[{xtype:'button', localized:{text:'ANALYSIS_SHOW_CONFIG'}, iconCls:'x-fal fa-cog', handler:function() {
    var widget = this.up('[isBpcWidget\x3dtrue]');
    widget.getLayout().setActiveItem(widget.settingPanel);
  }}, {xtype:'box', html:'\x3ch3\x3e' + BpcCommon.Api.getTranslation('FORMS_WIDGET_INVALID_CONFIG') + '\x3c/h3\x3e'}]});
  this.checkConfiguration();
}, checkConfiguration:function() {
  if (!this.moduleId) {
    this.getLayout().setActiveItem(this.wrongConfigPanel);
  } else {
    this.showContent();
  }
}, showContent:function() {
  if (!this.contentPanel) {
    this.remove(this.contentPanel);
  }
  var formInstanceId = this.moduleId;
  if (formInstanceId) {
    this.contentPanel = this.add({xtype:'formsWidgetContent', widgetTitle:this.widgetTitle, moduleId:formInstanceId});
    this.getLayout().setActiveItem(this.contentPanel);
  } else {
    this.getLayout().setActiveItem(this.wrongConfigPanel);
  }
}, onApplyConfiguration:function() {
  var widgetConfigurator = this.down('formsWidgetConfigurator');
  this.moduleId = widgetConfigurator.moduleId;
  this.widgetTitle = widgetConfigurator.widgetTitle;
  this.setWidgetConfiguration({moduleId:this.moduleId, title:this.widgetTitle, iconCls:this.widgetIconCls});
  this.fireEvent('widgetConfigurationChange', this);
  this.checkConfiguration();
}});
Ext.define('forms.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['forms.view.widget.Widget'], config:{moduleConfigurationComponents:['formsLiveView', 'formsList'], moduleInstanceConfigurationComponents:['formsModuleInstanceEditor'], defaultModuleInstanceConfigurationComponent:'formsModuleInstanceEditor', baseModuleView:'forms.view.List', mainView:null, css:true, widgets:['forms.view.widget.Widget']}});
Ext.define('forms.model.FormVersion', {extend:'forms.model.Form', idProperty:'version'});
Ext.define('forms.plugin.Interface', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'BPC Forms Plugin', COMPONENT_XTYPE:'formsPlugin', PLUGIN_ID:'bpcForms', DEFAULT_CONFIGURATION:{moduleId:null, formUrl:null, formConfig:null, formId:null, formVersion:null, debug:null, initialData:null}}});
Ext.define('forms.view.Main', {extend:'Ext.container.Container', alias:'widget.formsMain', layout:'fit', scrollable:false, moduleId:undefined, moduleCfg:undefined, moduleRoute:undefined, initialData:undefined, initComponent:function() {
  var me = this;
  me.items = [{xtype:'formsForm', formUrl:me.formUrl || BpcCommon.Api.getSetting(me.moduleId, forms.Config.FORM_URL), formConfig:me.formConfig || BpcCommon.Api.getSetting(me.moduleId, forms.Config.EMBEDDED_FORM), formId:me.formId || BpcCommon.Api.getSetting(me.moduleId, forms.Config.FORM_ID), formVersion:me.formVersion || BpcCommon.Api.getSetting(me.moduleId, forms.Config.FORM_VERSION), debug:me.debug || BpcCommon.Api.getSetting('forms', forms.Config.DEBUG) || false, initialData:me.initialData}];
  me.callParent();
  me.form = me.down('formsForm');
  me.submitData = me.form.submitData.bind(me.form);
  me.validateData = me.form.validateData.bind(me.form);
  me.resetForm = me.form.resetForm.bind(me.form);
  me.updateInstance(me.moduleCfg, me.moduleRoute);
}, updateInstance:function() {
}});
Ext.define('forms.plugin.View', {extend:'forms.view.Main', alias:'widget.formsPlugin', initComponent:function() {
  var me = this;
  me.pluginConfiguration = me.pluginConfiguration || {};
  if (Ext.isObject(me.pluginConfiguration.configuration)) {
    Ext.apply(me, me.pluginConfiguration.configuration);
  }
  if (Ext.isObject(me.pluginConfiguration.context) && me.pluginConfiguration.context.record) {
    me.initialData = {record:me.pluginConfiguration.context.record.getData()};
  }
  me.callParent();
}});
Ext.define('FormHistory', {extend:'Ext.data.Store', model:'forms.model.Form', proxy:{type:'rest', url:'cxf/bpc-forms/history', writer:{type:'json', writeAllFields:true}}});
Ext.define('forms.view.Editor', {extend:'Ext.panel.Panel', alias:'widget.formsEditor', iconCls:BpcCommon.Icons.EDIT, viewModel:{data:{form:{id:undefined, name:undefined, version:undefined, config:undefined}}}, bind:{title:BpcCommon.lang.Current.FORMS_EDITOR + ' - {form.name} ({form.id}/{form.version})'}, layout:{type:'vbox', align:'stretch'}, form:undefined, bodyPadding:10, buttons:[{iconCls:BpcCommon.Icons.CANCEL, itemId:'cancelBtn', ui:'secondary', hidden:true, listeners:{'afterrender':function(btn) {
  var window = btn.up('window');
  if (window) {
    btn.show();
  }
}}, localized:{text:'CORE_CANCEL'}, handler:function() {
  var me = this.up('formsEditor');
  var window = me.up('window');
  if (window) {
    window.close();
  }
}}, {iconCls:BpcCommon.Icons.SAVE, itemId:'saveBtn', ui:'primary', localized:{text:'FORMS_SAVE'}, handler:function() {
  var me = this.up('formsEditor');
  var unlockFn = BpcCommon.Util.blockComponentForAsyncAction('saveBtn', 'itemId', 'CORE_SAVE', '^ formsEditor');
  me.form.save({success:function() {
    unlockFn();
    Ext.getStore('bpcForms').reload();
    var window = me.up('window');
    if (window) {
      window.close();
    }
  }, failure:function(record, operation) {
    unlockFn();
    try {
      var response = operation.error.response;
      if (response && response.responseJson) {
        var errorObj = response.responseJson.error;
        if (errorObj && errorObj.name === 'VALIDATION_INVALID_INPUT' && Ext.isArray(errorObj.properties.errors)) {
          var errorMessage = '';
          var errors = errorObj.properties.errors;
          Ext.each(errors, function(message) {
            errorMessage = errorMessage.concat('\x26#149; ' + message + '\x3cbr\x3e');
          });
          if (errorMessage) {
            errorMessage = BpcCommon.Api.getTranslation('FORMS_VALIDATION_ERRORS') + ':\x3cbr\x3e' + errorMessage;
          }
          BpcCommon.Msg.show({title:BpcCommon.Api.getTranslation('CORE_ERROR'), icon:BpcCommon.Msg.ERROR, modal:false, message:errorMessage, buttons:BpcCommon.Msg.OK});
        }
      } else {
        BpcCommon.Msg.show({title:BpcCommon.Api.getTranslation('CORE_ERROR'), icon:BpcCommon.Msg.ERROR, modal:false, message:BpcCommon.Api.getTranslation('CORE_UNKNOWN_ERROR'), buttons:BpcCommon.Msg.OK});
      }
    } catch (err) {
      BpcCommon.Msg.show({title:BpcCommon.Api.getTranslation('CORE_ERROR'), icon:BpcCommon.Msg.ERROR, modal:false, message:BpcCommon.Api.getTranslation('CORE_UNKNOWN_ERROR'), buttons:BpcCommon.Msg.OK});
    }
  }});
}}], items:[{xtype:'bpcTextField', fieldLabel:'Name', bind:'{form.name}'}, {xtype:'formsFormConfigEditor', fieldLabel:'Name', flex:1, minHeight:200, bind:'{form.config}'}], initComponent:function() {
  var me = this;
  me.getViewModel().set('form', me.form);
  me.callParent();
}});
Ext.define('forms.view.Form', {extend:'Ext.ux.IFrame', alias:'widget.formsForm', formUrl:undefined, formConfig:undefined, formId:undefined, formVersion:undefined, formModel:undefined, debug:false, iFrameCommunicationTimeout:5000, pendingRequestMap:undefined, initialData:undefined, initComponent:function() {
  var me = this;
  var language = BpcCommon.Api.getSetting('_core', 'language');
  var rendererUrl = BpcCommon.Api.getSetting('forms', forms.Config.RENDERER_URL);
  me.formUrl = me.formUrl || '';
  me.src = rendererUrl + '?formUrl\x3d' + me.formUrl + '\x26debugMode\x3d' + me.debug + '\x26language\x3d' + language + '\x26sourceId\x3d' + me.getId();
  var initIframeDeferred = new Ext.Deferred();
  initIframeDeferred.then(me.initIframe.bind(me));
  me.pendingRequestMap = {ready:initIframeDeferred};
  me.callParent();
  window.addEventListener('message', function(event) {
    var eventData = Ext.JSON.decode(event.data, true);
    if (eventData && eventData.destinationId === me.getId()) {
      me.onMessageReceived(eventData);
    }
  }, false);
}, initIframe:function() {
  var me = this;
  if (!me.formUrl || String(me.formUrl).toLowerCase() === 'iframe') {
    if (!me.formConfig) {
      return me.loadFormFromRepo().then(me.initIframe.bind(me));
    }
    me.postMessageWithBackChannel('setFormConfig', me.formConfig).then(function() {
      if (me.initialData) {
        me.setFormData(me.initialData);
      }
    });
  } else if (me.initialData) {
    me.setFormData(me.initialData);
  }
}, loadFormFromRepo:function() {
  var me = this;
  var deferred = new Ext.Deferred();
  forms.model.Form.load(String(me.formId), {params:{version:me.formVersion}, scope:me, failure:function(record, operation) {
    BpcCommon.Api.showNotification({type:'ERROR', text:'FORMS_LOAD_FAILED'});
    deferred.reject(BpcCommon.Util.getErrorFromFailureResponse(operation.getResponse()));
  }, success:function(form) {
    me.formModel = form;
    me.formConfig = form.get('config');
    deferred.resolve(form);
  }});
  return deferred.promise;
}, postMessage:function(message) {
  var me = this;
  var postMsg = message;
  if (!Ext.isString(message)) {
    postMsg = JSON.stringify(postMsg);
  }
  me.getWin().postMessage(postMsg, '*');
}, onMessageReceived:function(messageObject) {
  var me = this;
  if (messageObject.requestName && me.pendingRequestMap[messageObject.requestName]) {
    me.pendingRequestMap[messageObject.requestName].resolve(messageObject.response);
  }
  me.fireEvent('messageReceived', me, messageObject);
}, getFormConfig:function() {
  var me = this;
  return me.postMessageWithBackChannel('getFormConfig', {});
}, setFormData:function(data) {
  var me = this;
  return me.postMessageWithBackChannel('setData', data);
}, submitData:function(messageObject) {
  var me = this;
  return me.postMessageWithBackChannel('submitData', messageObject || {});
}, validateData:function() {
  var me = this;
  return me.postMessageWithBackChannel('validateData', {});
}, resetForm:function() {
  var me = this;
  return me.postMessageWithBackChannel('resetForm', {});
}, postMessageWithBackChannel:function(requestName, messageObject) {
  var me = this;
  if (me.pendingRequestMap[requestName]) {
    return me.pendingRequestMap[requestName].promise;
  }
  var deferred = new Ext.Deferred();
  me.pendingRequestMap[requestName] = deferred;
  me.postMessage({requestName:requestName, request:messageObject, sourceId:me.getId()});
  var promiseWithTimeout = Ext.Deferred.timeout(deferred.promise, me.iFrameCommunicationTimeout);
  promiseWithTimeout.then(function() {
    delete me.pendingRequestMap[requestName];
  }, function() {
    delete me.pendingRequestMap[requestName];
  });
  return promiseWithTimeout;
}});
Ext.define('forms.view.FormConfigEditor', {extend:'Ext.Container', alias:'widget.formsFormConfigEditor', layout:{type:'hbox', align:'stretch'}, viewModel:true, config:{value:{}, previewExpanded:false}, publishes:'value', defaultBindProperty:'value', items:[{xtype:'panel', layout:'fit', flex:1, items:[{xtype:'bpcJsonField', itemId:'formConfigJson', jsonSchema:'bpc-fe-forms/resources/formConfig.json', bind:{value:'{value}'}}]}, {xtype:'panel', itemId:'preview', iconCls:BpcCommon.Icons.PREVIEW, localized:{title:'FORMS_PREVIEW'}, 
split:true, collapsed:true, collapsable:true, titleCollapse:true, collapseDirection:'right', layout:'fit', flex:1, bind:{formConfig:'{value}'}, setFormConfig:function(formConfig) {
  this.removeAll();
  this.add({xtype:'formsForm', formConfig:formConfig, debug:this.lookupViewModel().get('debugMode'), frameName:Ext.id(null, 'forms-live-view-')});
}, items:[{html:'nothing'}]}], initComponent:function() {
  var me = this;
  me.callParent();
  me.getViewModel().bind('{value}', me.setValue, me);
}});
Ext.define('forms.view.FormConfigLiveView', {extend:'Ext.panel.Panel', alias:'widget.formsLiveView', localized:{title:'FORMS_LIVE_VIEW'}, iconCls:BpcCommon.Icons.PREVIEW, layout:{type:'hbox', align:'stretch'}, viewModel:{data:{formConfig:{'metaData':{'author':'Virtimo AG', 'name':'Live PReview Form', 'id':999999, 'version':1}, 'components':[{'layout':'vertical', 'components':[{'type':'html', 'value':'\x3cb\x3eLive\x3c/b\x3e View'}, {'id':'lastName', 'label':{'de':'Nachname', 'en':'Lastname'}, 'type':'textfield', 
'value':'/data/lastName'}, {'id':'firstName', 'label':{'de':'Vorname', 'en':'Firstname'}, 'type':'textfield', 'value':'/data/firstName'}, {'layout':'vertical', 'components':[{'layout':'horizontal', 'components':[{'id':'street', 'label':{'de':'Straße', 'en':'Street'}, 'type':'textfield', 'value':'/data/address/street'}, {'id':'streetNumber', 'label':{'de':'Hausnummer', 'en':'Number'}, 'type':'textfield'}], 'type':'container'}, {'layout':'horizontal', 'components':[{'id':'city', 'label':{'de':'Stadt', 
'en':'City'}, 'type':'textfield'}, {'id':'country', 'label':{'de':'Land', 'en':'Country'}, 'type':'textfield'}], 'type':'container'}], 'label':{'de':'Adresse', 'en':'Address'}, 'type':'fieldset'}, {'id':'consent', 'label':{'de':'OK?', 'en':'O.K.?'}, 'type':'checkbox'}, {'layout':'horizontal', 'components':[{'action':'reset', 'label':{'de':'Zurücksetzen', 'en':'reset'}, 'type':'button'}, {'action':'validate', 'label':{'de':'Formular validieren', 'en':'validate form'}, 'type':'button'}, {'action':'submit', 
'label':{'de':'Formular abschicken', 'en':'submit form'}, 'type':'button'}], 'type':'container'}], 'type':'container'}], 'dataSchema':{'type':'object', 'properties':{'lastName':{'minLength':1, 'description':'The last part of the name', 'type':'string'}, 'firstName':{'minLength':1, 'description':'The first part of the name', 'type':'string'}}, 'required':['lastName']}, 'configuration':{'validateOnChange':false, 'defaultLanguage':'de', 'validateOnBlur':true}, 'state':{'data':{}, 'language':'de'}}, 
debugMode:false}}, items:[{xtype:'panel', layout:'fit', width:600, buttons:[{xtype:'bpcModuleInstanceSelector', baseModuleName:'forms', localized:{fieldLabel:'FORMS_LOAD_FROM_FORM'}, labelWidth:250, flex:1, collapseDirection:'left', forceSelection:true, listeners:{change:function(cmp, formsInstanceId) {
  var unlockFn = BpcCommon.Util.blockComponentForAsyncAction(cmp.id, 'id', undefined, '^ formsLiveView');
  var formUrl = BpcCommon.Api.getSetting(formsInstanceId, forms.Config.FORM_URL);
  if (formUrl && formUrl !== 'iframe') {
    Ext.Ajax.request({url:formUrl, success:function(response) {
      BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('FORMS_LOADED_FORM_URL') + ' - ' + formUrl);
      cmp.lookupViewModel().set('formConfig', Ext.decode(response.responseText, true));
    }, callback:unlockFn});
    return;
  }
  var formConfig = BpcCommon.Api.getSetting(formsInstanceId, forms.Config.EMBEDDED_FORM);
  if (Ext.isObject(formConfig) && formConfig) {
    cmp.lookupViewModel().set('formConfig', formConfig);
    BpcCommon.Api.showNotification('FORMS_LOADED_EMBEDDED_FORM');
    return unlockFn();
  }
  forms.model.Form.load(String(BpcCommon.Api.getSetting(formsInstanceId, forms.Config.FORM_ID)), {params:{version:BpcCommon.Api.getSetting(formsInstanceId, forms.Config.FORM_VERSION)}, failure:function() {
    BpcCommon.Api.showNotification({type:'ERROR', text:'FORMS_LOAD_FAILED'});
  }, success:function(form) {
    cmp.lookupViewModel().set('formConfig', form.get('config'));
  }, callback:unlockFn});
  return unlockFn();
}}}, {xtype:'checkbox', bind:'{debugMode}', fieldLabel:'debug'}], items:[{xtype:'bpcJsonField', jsonSchema:'bpc-fe-forms/resources/formConfig.json', bind:{value:'{formConfig}'}}]}, {xtype:'splitter', collapsible:true, collapseTarget:'prev'}, {xtype:'container', layout:'fit', flex:1, cls:'forms-live-view', bind:{formConfig:'{formConfig}'}, setFormConfig:function(formConfig) {
  this.removeAll();
  this.add({xtype:'formsForm', formConfig:formConfig, debug:this.lookupViewModel().get('debugMode'), frameName:'forms-live-view'});
}, items:[{html:'nothing'}]}]});
Ext.define('forms.view.FormSourceSelector', {extend:'Ext.form.field.Picker', alias:'widget.formsFormSourceSelector', controller:'formsFormSourceSelectorController', editable:false, config:{embeddedForm:null, formId:'', formUrl:''}, publishes:['embeddedForm', 'formId', 'formUrl'], updateAttributeTpl:function(attributeName, attributeValue) {
  var me = this;
  var value = me.getValue() || {};
  if (value[attributeName] !== attributeValue) {
    var newValue = {embeddedForm:null, formId:'', formUrl:''};
    newValue[attributeName] = attributeValue;
    me.setValue(newValue);
  }
}, updateEmbeddedForm:function(newVal) {
  this.updateAttributeTpl('embeddedForm', newVal);
}, updateFormId:function(newVal) {
  this.updateAttributeTpl('formId', newVal);
}, updateFormUrl:function(newVal) {
  this.updateAttributeTpl('formUrl', newVal);
}, getValue:function() {
  var me = this;
  return me.value;
}, valueToRaw:function(value) {
  var me = this;
  if (value.embeddedForm) {
    me.setEmbeddedForm(value.embeddedForm);
    me.setFormId(null);
    me.setFormUrl(null);
    return 'Embedded: ' + Ext.encode(value.embeddedForm, true);
  } else if (value.formId) {
    me.setFormId(value.formId);
    me.setEmbeddedForm(null);
    me.setFormUrl(null);
    var formsStore = Ext.StoreManager.get('bpcForms');
    if (!formsStore) {
      return 'Repository: ' + value.formId;
    } else if (formsStore && formsStore.isLoaded()) {
      var record = formsStore.getById(value.formId);
      return 'Repository: ' + record.get('name') + ' (Version: ' + record.get('version') + ', ID ' + value.formId + ')';
    }
    formsStore.load({callback:function(records, operation, success) {
      if (success) {
        var record$0 = formsStore.getById(value.formId);
        me.setRawValue('Repository: ' + record$0.get('name') + ' (Version: ' + record$0.get('version') + ', ID ' + value.formId + ')');
      }
    }});
    return 'Repository: ' + value.formId;
  } else if (value.formUrl) {
    me.setFormUrl(value.formUrl);
    me.setFormId(null);
    me.setEmbeddedForm(null);
    return 'URL: ' + value.formUrl;
  }
  return '';
}, createPicker:function() {
  var me = this;
  var activeTabIndex = 0;
  if (me.getFormUrl()) {
    activeTabIndex = 1;
  } else if (me.getEmbeddedForm()) {
    activeTabIndex = 2;
  }
  return Ext.create({xtype:'tabpanel', itemId:'formsPicker', plugins:['bpcFocusKeeper'], floating:true, pickerField:me, controller:me.controller, minHeight:300, activeTab:activeTabIndex, items:[{xtype:'grid', itemId:'repository', localized:{title:'FORMS_REPOSITORY'}, iconCls:forms.Config.FORMS_ICON_REPOSITORY, store:'bpcForms', columnLines:true, selModel:{type:'checkboxmodel', mode:'SINGLE'}, columns:[{text:'ID', dataIndex:'id'}, {text:'Version', dataIndex:'version'}, {text:'Name', dataIndex:'name', 
  flex:1}, {localized:{text:'CORE_DATE'}, xtype:'datecolumn', dataIndex:'timestamp'}], listeners:{afterrender:function(grid) {
    if (grid.store.isLoaded()) {
      grid.setSelection(grid.store.getById(me.getFormId()));
    } else {
      grid.store.load({callback:function(records, operation, success) {
        if (success) {
          grid.setSelection(grid.store.getById(me.getFormId()));
        }
      }});
    }
  }}, bbar:[{xtype:'bpcGridFilterField', grid:'^ #formsPicker #repository', flex:1}]}, {xtype:'panel', itemId:'url', localized:{title:'FORMS_SOURCE_URL'}, iconCls:forms.Config.FORMS_ICON_URL, layout:{type:'vbox', align:'stretch'}, bodyPadding:5, items:[{xtype:'bpcTextField', itemId:'sourceUrl', localized:{fieldLabel:'FORMS_SOURCE_URL'}, value:me.getFormUrl()}]}, {localized:{title:'FORMS_SOURCE_EMBEDDED'}, iconCls:forms.Config.FORMS_ICON_EMBEDDED, xtype:'bpcJsonField', itemId:'embedded', jsonSchema:'bpc-fe-forms/resources/formConfig.json', 
  flex:1, value:me.getEmbeddedForm() || forms.Config.MINIMAL_FORMS_CONFIG}], buttons:['-\x3e', {iconCls:BpcCommon.Icons.OK, ui:'primary', localized:{text:'CORE_APPLY'}, handler:'applySelection'}]});
}, listeners:{'click':{fn:function() {
  this.component.expand();
}, element:'inputEl'}}});
Ext.define('form.view.FormSourceSelectorController', {extend:'Ext.app.ViewController', alias:'controller.formsFormSourceSelectorController', applySelection:function() {
  var me = this;
  if (me.getView().getActiveTab() === me.getView().down('#repository')) {
    me.getView().pickerField.setValue({embeddedForm:null, formId:me.getView().down('#repository').getSelection()[0].getId(), formUrl:null});
  } else if (me.getView().getActiveTab() === me.getView().down('#url')) {
    me.getView().pickerField.setValue({embeddedForm:null, formId:null, formUrl:me.getView().down('#url #sourceUrl').getValue()});
  } else {
    me.getView().pickerField.setValue({embeddedForm:me.getView().down('#embedded').getValue(), formId:null, formUrl:null});
  }
  me.getView().pickerField.collapse();
}});
Ext.define('forms.view.List', {extend:'Ext.grid.Panel', alias:'widget.formsList', controller:'formsListController', localized:{title:'FORMS_REPOSITORY'}, iconCls:forms.Config.FORMS_ICON_REPOSITORY, store:'bpcForms', cls:'forms-list', plugins:{ptype:'rowexpander', rowBodyTpl:'\x3cdiv id\x3d"{[BpcCommon.Util.cleanUpId(\'bpcFormsHistoryFor-\' + values.id)]}"\x3e\x3c/div\x3e'}, buttons:[{iconCls:BpcCommon.Icons.REFRESH, ui:'secondary', localized:{text:'CORE_REFRESH'}, handler:function() {
  var me = this;
  me.up('formsList').store.reload();
}}, {iconCls:BpcCommon.Icons.ADD, ui:'primary', localized:{text:'FORMS_ADD'}, handler:'addForm'}], columns:[{text:'ID', dataIndex:'id'}, {text:'Version', dataIndex:'version'}, {text:'Name', dataIndex:'name', flex:1}, {localized:{text:'CORE_DATE'}, xtype:'datecolumn', dataIndex:'timestamp'}, {xtype:'actioncolumn', text:'', width:64, align:'center', items:[{iconCls:BpcCommon.Icons.PREVIEW, localized:{tooltip:'FORMS_PREVIEW'}, handler:'previewForm'}, {iconCls:BpcCommon.Icons.EDIT, localized:{tooltip:'FORMS_EDITOR'}, 
handler:'editForm', isActionDisabled:function(view, rowIndex, colIndex, item, record) {
  return record.get('disabled') || false;
}, getTip:function(v, metadata, record) {
  if (record.get('disabled')) {
    return BpcCommon.Api.getTranslation('FORMS_EDITOR_BLOCKED');
  }
  return '';
}}]}], listeners:{afterrender:function(grid) {
  grid.store.load(function(records, operation, success) {
    if (success) {
      var lockIds = BpcCommon.Api.getLockInformation('forms_repository');
      if (lockIds) {
        Ext.each(lockIds, function(id) {
          var record = grid.store.getById(id);
          record.set('disabled', true);
        });
      }
    }
  });
}}, viewConfig:{getRowClass:function(record, index) {
  var disabled = record.get('disabled');
  if (disabled) {
    var formsList = this.up('formsList');
    var rowExpander = formsList.findPlugin('rowexpander');
    var recordNode = this.getNodeByRecord(record);
    if (!recordNode.classList.contains('x-grid-row-collapsed') && rowExpander) {
      rowExpander.toggleRow(index, record);
    }
    return 'forms-edit-disabled';
  }
  return 'forms-edit-enabled';
}}, initComponent:function() {
  var $jscomp$this = this;
  var setLockData = function(shoudLock, data) {
    if (data && data.properties && data.properties.data) {
      var lockObj = data.properties.data.lock;
      if (lockObj) {
        var moduleId = lockObj.moduleId;
        if (moduleId === 'forms_repository') {
          if (lockObj.id) {
            var formId = lockObj.id.split('forms_repository_')[1];
            if (formId) {
              var record = $jscomp$this.getStore().getById(formId);
              if (record) {
                record.set('disabled', shoudLock);
              }
            }
          }
        }
      }
    }
  };
  Ext.on('coreDataLocked', function(data) {
    setLockData(true, data);
  });
  Ext.on('coreDataUnlocked', function(data) {
    setLockData(false, data);
  });
  this.callParent();
}});
Ext.define('form.view.ListController', {extend:'Ext.app.ViewController', alias:'controller.formsListController', control:{'formsList \x3e gridview':{expandbody:'onExpandBody', collapsebody:'onCollapseBody'}}, defaultFormConfig:{'metaData':{'name':'Example Form', 'id':1, 'version':1}, 'components':[{'layout':'vertical', 'components':[{'label':{'de':'Name', 'en':'name'}, 'type':'textfield', 'value':'/data/name'}], 'type':'container'}], 'configuration':{}, 'state':{'data':{'name':'Mia Mustermensch'}}}, 
addForm:function() {
  var me = this;
  Ext.create({xtype:'bpcWindow', maximizable:true, items:[{xtype:'formsEditor', form:Ext.create('forms.model.Form', {id:Date.now(), version:1, name:'Form', config:me.defaultFormConfig})}]}).show();
}, editForm:function(tableView, rowIndex, colIndex, item, e, record) {
  BpcCommon.Api.lockData('forms_repository', record.get('id'));
  Ext.create({xtype:'bpcWindow', maximizable:true, items:[{xtype:'formsEditor', form:record}], listeners:{close:function() {
    BpcCommon.Api.unlockData('forms_repository', record.get('id'));
  }}}).show();
}, previewForm:function(tableView, rowIndex, colIndex, item, e, record) {
  Ext.create({xtype:'bpcWindow', maximizable:true, items:[{xtype:'formsForm', formId:record.get('id'), formVersion:record.get('version')}]}).show();
}, onExpandBody:function(rowNode, record) {
  var me = this;
  var target = Ext.get(BpcCommon.Util.cleanUpId('bpcFormsHistoryFor-' + record.getId()));
  var visibleWidth = me.getView().getView().getWidth() - 64;
  var parentWidth = target.getWidth();
  record.historyCmp = Ext.create({xtype:'grid', controller:'formsListController', disabled:record.get('disabled'), store:{model:'forms.model.FormVersion', autoLoad:true, proxy:{type:'rest', url:'cxf/bpc-forms/history/' + record.getId()}}, width:parentWidth < visibleWidth ? parentWidth : visibleWidth, columns:Object.getPrototypeOf(me.getView()).columns, renderTo:target, resizable:{handles:'s'}, padding:0});
}, onCollapseBody:function(rowNode, record) {
  if (record.historyCmp) {
    record.historyCmp.destroy();
    delete record.historyCmp;
  }
}});
Ext.define('forms.view.ModuleInstanceEditor', {extend:'Ext.panel.Panel', alias:'widget.formsModuleInstanceEditor', localized:{title:'FORMS_EDITOR', tooltip:'FORMS_EDITOR'}, iconCls:forms.Config.FORMS_ICON, layout:{type:'vbox', align:'stretch'}, bodyPadding:10, viewModel:{data:{hasUnsavedChanges:false}}, initComponent:function() {
  var vm = this.getViewModel();
  var settings = vm.get('moduleInstance.moduleModel.settings');
  settings.on('datachanged', function() {
    vm.set('hasUnsavedChanges', settings.isDirty());
  });
  this.callParent();
}, items:[{xtype:'bpcTextField', localized:{fieldLabel:'CORE_NAME'}, bind:{value:'{moduleInstance.module_name}'}}, {xtype:'formsFormSourceSelector', localized:{fieldLabel:'FORMS_SOURCE'}, bind:{formId:'{moduleInstance.formId}', formUrl:'{moduleInstance.formUrl}', embeddedForm:'{moduleInstance.embeddedForm}'}}], buttons:[{xtype:'bpcToolbarMsg', iconCls:BpcCommon.Icons.WARNING, iconColorCls:'warningColor', text:'CORE_UNSAVED_CHANGES', hidden:true, bind:{hidden:'{!hasUnsavedChanges}'}}, {ui:'primary', 
localized:{text:'CORE_SAVE'}, iconCls:BpcCommon.Icons.SAVE, handler:function(btn) {
  var settingStore = btn.lookupViewModel().get('moduleInstance.moduleModel.settings');
  if (settingStore.isDirty()) {
    var unlockFn = BpcCommon.Util.blockComponentForAsyncAction('formsModuleInstanceEditor', 'xtype');
    settingStore.sync({callback:function() {
      unlockFn();
    }});
  }
}}]});
Ext.define('forms.view.widget.FormsInstanceSelector', {extend:'Ext.form.field.ComboBox', alias:'widget.formsInstanceSelector', localized:{fieldLabel:'FORMS_WIDGET_NAME'}, initComponent:function() {
  var formInstances = BpcCommon.Api.getModuleInstances('forms');
  var formInstancesList = formInstances.getData().getRange();
  this.displayField = 'instanceName';
  this.valueField = 'moduleId';
  this.store = {data:formInstancesList.map(function(item) {
    return item.getData();
  })};
  this.callParent();
}});
Ext.define('forms.view.widget.WidgetConfigurator', {extend:'Ext.panel.Panel', alias:'widget.formsWidgetConfigurator', moduleId:undefined, reportId:undefined, bodyPadding:10, instanceSelector:undefined, reportSelector:undefined, widgetTitle:undefined, widgetIconCls:undefined, showReportTitle:false, scrollable:true, initComponent:function() {
  var $jscomp$this = this;
  this.defaults = {labelWidth:200};
  this.items = [{xtype:'bpcTextField', localized:{fieldLabel:'FORMS_WIDGET_TITLE_FIELD_LABEL'}, layout:'fit', listeners:{change:function(el, val) {
    $jscomp$this.widgetTitle = val;
  }}, value:this.widgetTitle}, {xtype:'formsInstanceSelector', value:this.moduleId, listeners:{change:function(el, val) {
    $jscomp$this.moduleId = val;
  }}}];
  this.buttons = [{xtype:'button', ui:'primary', localized:{text:'CORE_APPLY'}, iconCls:'fal fa-save', handler:this.onApplyConfiguration.bind(this)}];
  this.callParent();
}, onApplyConfiguration:function() {
  this.up().onApplyConfiguration();
}});
Ext.define('forms.view.widget.WidgetContent', {extend:'Ext.panel.Panel', alias:'widget.formsWidgetContent', moduleId:undefined, layout:'fit', flex:1, padding:0, initComponent:function() {
  this.items = [{xtype:'formsForm', layout:'fit', formUrl:BpcCommon.Api.getSetting(this.moduleId, forms.Config.FORM_URL), formConfig:BpcCommon.Api.getSetting(this.moduleId, forms.Config.EMBEDDED_FORM), formId:BpcCommon.Api.getSetting(this.moduleId, forms.Config.FORM_ID), formVersion:BpcCommon.Api.getSetting(this.moduleId, forms.Config.FORM_VERSION)}];
  this.callParent();
}});
