# Introduction

ESLint rules for BPC Frontend modules, to maintain and improve code quality.

ESLint editor extensions maybe useful for real time code checking.

# Using these rules in your Frontend Module

## Prerequisites

* Node.js 10.12.0 or above
* npm 6.4.1 or above (usually included with Node.js)
* ESLint 7.4.0 or above

### Prerequisites Installation Ubuntu 20.x
```
> sudo apt update
> sudo apt upgrade
> sudo apt install nodejs
> sudo apt install npm
> sudo npm i -g eslint
```

## Installation

Theses rules are provided as a npm package, hosted on [Virtimo Jfrog Artifactory](https://virtimo.jfrog.io/).

You might have to login to virtimo artifactory before installation. Please follow this [instruction](https://virtimo.atlassian.net/wiki/spaces/PROD/pages/1196884203/Artifactory+API+Authentication+mit+Google+User) to set your user, if you didn't have one.

Once you have a valid user and password, use these commands to login:

```bash
npm login --scope=@virtimo --registry https://virtimo.jfrog.io/artifactory/api/npm/virtimo-npm/
```

Then you can install this package with npm as usual

```bash
npm i --save-dev @virtimo/eslint-config-bpc
```

## Using in your module

To use the rules, which are provided in eslint-config-bpc package, your eslint config should extend this package. You can do it in your eslint config file (.eslintrc.*). Example:

```json
// .eslintrc.json
{
    "extends": "@virtimo/eslint-config-bpc"
}
```

If you have an eslint extension integrated in your code editor, these rules will be applied automatically. Or you can run ESLint on any file or directory like this:

```bash
./node_modules/.bin/eslint yourfile.js
```

# Adding new rules

Before you start adding new rule, please read the [official ESLint guide](https://eslint.org/docs/developer-guide/working-with-rules)

Then you can add new rules in "index.js"